## falconpl 0.9.6.4

=== CMakeLists.txt ===
ADD_SUBDIRECTORY(core)
SET(falcon_DIR ${CMAKE_CURRENT_BINARY_DIR}/core/devtools)
ADD_SUBDIRECTORY(modules/feathers)

=== core/CMakeLists.txt ===
##############################################################################
# The Falcon Programming language
#
# CMake configuration file for Core falcon
##############################################################################
#
# CONTROL VARIABLES:
#
# CMAKE_INSTALL_PREFIX - Installation directory
# FALCON_FINAL_DEST - Target final destination, if different from
#                    prefix, where Falcon will be finally installed.
#                    If not given, will be defaulted to CMAKE_INSTALL_PREFIX
# FALCON_BIN_DIR - Prefix for binary installation. Defaults to "bin"
# FALCON_INC_DIR - Prefix for installation of include files.
# FALCON_MAN_DIR - Prefix for installation of man files.
# FALCON_LIB_DIR - Prefix for installation of archives and dynamic libraries
#                  on UNIXes. Defaults to "lib".
# FALCON_MOD_DIR - Prefix for installation of modules. Defaults to
#                  $FALCON_LIB_DIR/falcon on UNICES, and bin/ on windows.
# FALCON_SKIP_BISON - ON to avoid using bison.
# FALCON_WITH_MANPAGES - ON to build and install man pages.
# FALCON_MAN_DIR - Where manual pages are stored (below prefix)
# DISABLE_RPATH  - Disable our detected settings for RPATH?
#                  (should then use command line CMAKE_RPATH* variables)
#

cmake_minimum_required(VERSION 2.6.2)
project(Falcon_Core)

option( FALCON_SKIP_BISON "Skip BISON to avoid recompiling grammar" ON )
option( FALCON_WITH_MANPAGES "Build and install also manpages" OFF )

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)

# NOTE modules are installed via
#   install(FILES .. DESTINATION ${FALCON_MOD_INSTALL_DIR})
# since they are neither RUNTIME, LIBRARY nor ARCHIVE.

#In windows, we normally install in c:\falcon
if(WIN32)
   #mingw requires -mthreads global option
   if(CMAKE_GENERATOR STREQUAL "MinGW Makefiles")
      message( "MINGW make detected, adding -mthreads flag" )
      list(APPEND CMAKE_EXE_LINKER_FLAGS -mthreads )
      list(APPEND CMAKE_SHARED_LINKER_FLAGS -mthreads )
      list(APPEND CMAKE_MODULE_LINKER_FLAGS -mthreads )
   endif()
endif(WIN32)
#
## </Subset of falcon-config.cmake>

if(WIN32)
   SET( FALCON_HOST_SYSTEM "WINDOWS" )
   SET( FALCON_SYSTEM_WIN 1 )
else()
   if(APPLE)
      set( FALCON_HOST_SYSTEM "MAC" )
      set( FALCON_SYSTEM_MAC 1 )
   elseif(UNIX)
      set( FALCON_HOST_SYSTEM "UNIX" )
      SET( FALCON_SYSTEM_UNIX 1 )
   else()
      message(FATAL_ERROR "Sorry, can't determine system type" )
   endif()
endif()

#SONAME and soversion (unix so library informations for engine)
# Remember that SONAME never follows project versioning, but
# uses a VERSION, REVISION, AGE format, where
# VERSION: generational version of the project
# REVISION: times this version has been touched
# AGE: Number of version for which binary compatibility is granted
# In eample, 1.12.5 means that this lib may be dynlinked against
# every program using this lib versioned from 1.8 to 1.12.
include(versioninfo.cmake)
if(NOT FALCON_SONAME_AGE)
   # A couple of useful shortcuts
   set(FALCON_SONAME "${FALCON_SONAME_VERSION}.${FALCON_SONAME_REVISION}.${FALCON_SONAME_AGE}")
   set(FALCON_SONAME_REV "${FALCON_SONAME_VERSION}.${FALCON_SONAME_REVISION}")
endif(NOT FALCON_SONAME_AGE)

#Automatically generated version info for RC scripts and sources
#CMAKE is good at this, let's use this feature
set(FALCON_VERSION_RC   "${FALCON_VERSION_MAJOR}, ${FALCON_VERSION_MINOR}, ${FALCON_VERSION_REVISION}, ${FALCON_VERSION_PATCH}")
set(FALCON_VERSION_ID   "${FALCON_VERSION_MAJOR}.${FALCON_VERSION_MINOR}.${FALCON_VERSION_REVISION}.${FALCON_VERSION_PATCH}")

message(STATUS "Compiling Falcon ${FALCON_VERSION_ID} on ${CMAKE_SYSTEM}" )

##############################################################################
#  Other defaults
##############################################################################
include(TestBigEndian)

message(STATUS "Testing endianity on ${CMAKE_SYSTEM}" )
TEST_BIG_ENDIAN(falcon_big_endian)
if(falcon_big_endian)
   set(FALCON_LITTLE_ENDIAN 0)
else(falcon_big_endian)
   set(FALCON_LITTLE_ENDIAN 1)
endif(falcon_big_endian)


# install prefix defaults, if not set
if(NOT CMAKE_INSTALL_PREFIX)
  #In windows, we normally install in c:\falcon
  if(WIN32)
    if($ENV{PRGORAMS})
      SET(CMAKE_INSTALL_PREFIX  "C:\\\\$ENV{PROGRAMS}\\\\falcon" )
    else()
      SET(CMAKE_INSTALL_PREFIX  "C:\\\\Program Files\\\\falcon" )
    endif()
  else()
    set(CMAKE_INSTALL_PREFIX  "/usr/local" )
  endif()
endif()

message( STATUS "Installation prefix: ${CMAKE_INSTALL_PREFIX}" )

if (NOT FALCON_FINAL_DEST )
   set( FALCON_FINAL_DEST "${CMAKE_INSTALL_PREFIX}" )
   message( "Defaulting FALCON_FINAL_DESTINATION to ${FALCON_FINAL_DEST}" )
else()
   message( "setting FALCON_FINAL_DESTINATION=${FALCON_FINAL_DEST}" )
endif()

if (NOT FALCON_LIB_DIR)
   set(FALCON_LIB_DIR lib)
endif()


if (NOT FALCON_BIN_DIR)
   set(FALCON_BIN_DIR bin)
endif()

if (NOT FALCON_INC_DIR)
   if(WIN32)
      set(FALCON_INC_DIR "include")
   else()
      set(FALCON_INC_DIR "include/falcon-${FALCON_VERSION_ID}")
   endif()
endif()

if (NOT FALCON_MOD_DIR )
   if(WIN32)
      set(FALCON_MOD_DIR bin)
   else()
      set(FALCON_MOD_DIR "${FALCON_LIB_DIR}/falcon")
   endif()
endif()

# for install(TARGETS .. ${FALCON_INSTALL_DESTINATIONS})
set(FALCON_INSTALL_DESTINATIONS
  RUNTIME DESTINATION ${FALCON_BIN_DIR}
  LIBRARY DESTINATION ${FALCON_LIB_DIR}
  ARCHIVE DESTINATION ${FALCON_LIB_DIR}
)

message( STATUS "Binary prefix: ${FALCON_BIN_DIR}" )
message( STATUS "Library prefix: ${FALCON_LIB_DIR}" )
message( STATUS "Module prefix: ${FALCON_MOD_DIR}" )

if ( NOT WIN32 )
   if (NOT FALCON_MAN_DIR)
      set(FALCON_MAN_DIR "share/man/man1")
   endif()
   message( STATUS "Manual pages: ${FALCON_MAN_DIR}" )
endif()

option(DISABLE_RPATH "http://wiki.debian.org/RpathIssue" off)
if(NOT DISABLE_RPATH)
  # Always find libfalcon_engine.so in build and install tree, without LD_LIBRARY_PATH.
  set(CMAKE_SKIP_BUILD_RPATH  false)
  set(CMAKE_BUILD_WITH_INSTALL_RPATH false)
     # RPATH must always point to the final destination
   # No matter if we installed directly there or in a temporary prefix
   if(CMAKE_INSTALL_RPATH)
      set(CMAKE_INSTALL_RPATH_USE_LINK_PATH true)
   else()
      set(CMAKE_INSTALL_RPATH "${FALCON_FINAL_DEST}/${FALCON_LIB_DIR}")
      set(CMAKE_INSTALL_RPATH_USE_LINK_PATH true)
   endif()
endif()

#########################################################à
# Subdirectories
#

add_subdirectory(engine)
add_subdirectory(clt)
add_subdirectory(devtools)

#also performs installation of the include directory
add_subdirectory(include)

# and man pages
if (FALCON_WITH_MANPAGES)
   add_subdirectory(manpages)   
endif()

#########################################################################
# Tests?

option(FALCON_WITH_CTEST_TESTS "" off)
if(FALCON_WITH_CTEST_TESTS)
  enable_testing()
  include(CTest)
  add_subdirectory(tests)
endif()

# CMake generated information.  Is used by our falcon-config.cmake
install(EXPORT falcon-core-targets
  DESTINATION ${FALCON_MOD_DIR}/cmake
)

=== core/devtools/CMakeLists.txt ===
#
# Configurator for development tools
#

IF(UNIX)
   SET(sys_in_spec falcon-conf )
   SET(sys_inst_spec ${CMAKE_CURRENT_BINARY_DIR}/falcon-conf)
ENDIF(UNIX)

SET(in_files
  falconeer.fal
  ${sys_in_spec}
)


foreach(item ${in_files} )
  message( "Configuring ${item}" )
  configure_file(
    ${item}.in  ${CMAKE_CURRENT_BINARY_DIR}/${item}
    ESCAPE_QUOTES @ONLY)
endforeach(item)

# CMake will find it via find_package(falcon [REQUIRED])
# It supplies include paths, libraries (via falcon-core-targets.cmake)
# and convenience MACROS.
#
message( "Configuring falcon-config.cmake" )
configure_file(
  falcon-config.cmake.in
  ${CMAKE_CURRENT_BINARY_DIR}/falcon-config.cmake
  @ONLY
)

########################################################################
# Install

SET(inst_files
  "${CMAKE_CURRENT_BINARY_DIR}/falconeer.fal"
  "fallc.fal"
  ${sys_inst_spec}
)


INSTALL(
  FILES ${inst_files}
  DESTINATION ${FALCON_BIN_DIR}
  PERMISSIONS OWNER_READ OWNER_WRITE 
              OWNER_EXECUTE
              GROUP_READ GROUP_EXECUTE
              WORLD_READ WORLD_EXECUTE
)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/falcon-config.cmake
  DESTINATION ${FALCON_MOD_DIR}/cmake
)

=== core/engine/CMakeLists.txt ===
##################################################
# Falcon Programming Language
#
##################################################

#Engine specific define
add_definitions(-DFALCON_ENGINE_EXPORTS)

include_directories(
  ${PROJECT_BINARY_DIR}/include
  ${PROJECT_SOURCE_DIR}/include
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}/core_module  
)

message(STATUS "Compiling Falcon core on ${CMAKE_SYSTEM_NAME}" )

#Specific system files
if(UNIX OR APPLE)
  set(SYS_SPECIFIC
    baton_posix.cpp
    dir_sys_unix.cpp
    fstream_sys_unix.cpp
    mt_posix.cpp
    stdstreams_unix.cpp
    time_sys_unix.cpp
    vm_sys_posix.cpp
    vfs_file_unix.cpp
    signals_posix.cpp
  )

  #for solaris system flavor, add sys_solaris.cpp
  if(CMAKE_SYSTEM_NAME STREQUAL "SunOS" )
    list(APPEND SYS_SPECIFIC sys_solaris.cpp)
  else()
    list(APPEND SYS_SPECIFIC sys_unix.cpp)
  endif()

  #DL is different for unix and mac
  if(APPLE)
    list(APPEND SYS_SPECIFIC 
      heap_bsd.cpp 
      dll_mac.cpp 
    )
  elseif(CMAKE_SYSTEM_NAME STREQUAL "BSD")
    list(APPEND SYS_SPECIFIC
      heap_bsd.cpp
      dll_dl.cpp 
    )
  else()
    list(APPEND SYS_SPECIFIC
      heap_posix.cpp
      dll_dl.cpp
    )
  endif()

  option(FALCON_SKIP_BISON "Don't perform grammar recompilation" on)
  if(NOT FALCON_SKIP_BISON)
    find_program(BISON_EXECUTABLE bison)
    if(NOT BISON_EXECUTABLE)
      message(FATAL_ERROR "BISON not found - Turn on FALCON_SKIP_BISON to not perform grammar recompilation")
    endif(NOT BISON_EXECUTABLE)
    
    # Builds out-of-source. Copy into the source tree and commit to svn, if desired.
    add_custom_command(
      DEPENDS 
        ${PROJECT_SOURCE_DIR}/include/falcon/syntree.h
        ${CMAKE_CURRENT_SOURCE_DIR}/src_parser.yy
      COMMAND 
        ${BISON_EXECUTABLE} -y ${CMAKE_CURRENT_SOURCE_DIR}/src_parser.yy 
                            -o ${CMAKE_CURRENT_SOURCE_DIR}/src_parser.cpp       
      OUTPUT
        ${CMAKE_CURRENT_SOURCE_DIR}/src_parser.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/src_parser.hpp 
      COMMENT "Creating src_parser.cpp"
    )

  endif(NOT FALCON_SKIP_BISON)

elseif(WIN32)

  set(SYS_SPECIFIC
    baton_win.cpp
    dir_sys_win.cpp
    dll_win.cpp
    fstream_sys_win.cpp
    heap_win.cpp
    mt_win.cpp
    stdstreams_win.cpp
    sys_win.cpp
    time_sys_win.cpp
    vm_sys_win.cpp
    vfs_file_win.cpp
    falcon_engine.rc
    signals_win.cpp
  )
endif()

#####################################################################################
# Including headers in the source list helps CMAKE to build better IDE project files.

file(GLOB FALCON_HEADERS "../include/falcon/*.h" )

#################

set(CORE_MODULE_SOURCES
  core_module/array_ext.cpp
  core_module/attrib_ext.cpp
  core_module/cmdlineparser.cpp
  core_module/complex_ext.cpp
  core_module/continuation_ext.cpp  
  core_module/core_module.cpp
  core_module/coroutine_ext.cpp
  core_module/dict_ext.cpp
  core_module/dir_ext.cpp
  core_module/envvars.cpp
  core_module/error_ext.cpp
  core_module/fal_include.cpp
  core_module/file_ext.cpp
  core_module/format_ext.cpp
  core_module/function_ext.cpp
  core_module/functional_ext.cpp
  core_module/gc_ext.cpp
  core_module/input.cpp
  core_module/inspect.cpp
  core_module/item_ext.cpp
  core_module/iterator_ext.cpp
  core_module/list_ext.cpp
  core_module/math_ext.cpp
  core_module/membuf_ext.cpp
  core_module/message_ext.cpp
  core_module/oob_ext.cpp
  core_module/pagedict_ext.cpp
  core_module/param_ext.cpp
  core_module/path_ext.cpp
  core_module/poopseq_ext.cpp
  core_module/print.cpp
  core_module/random.cpp
  core_module/seconds.cpp
  core_module/sequence_ext.cpp
  core_module/serialize.cpp
  core_module/set_ext.cpp
  core_module/string_ext.cpp
  core_module/state_ext.cpp
  core_module/stringstream_ext.cpp
  core_module/sys_ext.cpp
  core_module/table.cpp
  core_module/time_ext.cpp
  core_module/transcode_ext.cpp
  core_module/tokenizer_ext.cpp
  core_module/uri_ext.cpp
  core_module/vminfo_ext.cpp
)


add_library(falcon_engine SHARED
  attribmap.cpp
  autocstring.cpp
  autowstring.cpp
  basealloc.cpp
  cacheobject.cpp
  crobject.cpp
  compiler.cpp
  complex.cpp
  continuation.cpp
  corearray.cpp
  coreclass.cpp
  coredict.cpp
  corefunc.cpp
  coreobject.cpp
  coreslot.cpp
  coretable.cpp
  debug.cpp
  deptab.cpp
  error.cpp
  falcondata.cpp
  falconobject.cpp
  fassert.cpp
  filestat.cpp
  format.cpp
  garbageable.cpp
  gcalloc.cpp
  gencode.cpp
  generatorseq.cpp
  genericlist.cpp
  genericmap.cpp
  genericvector.cpp
  genhasm.cpp
  gentree.cpp
  globals.cpp
  intcomp.cpp
  item.cpp
  item_co.cpp
  itemarray.cpp
  itemlist.cpp
  itemserial.cpp
  itemset.cpp
  itemtraits.cpp
  iterator.cpp
  lineardict.cpp
  linemap.cpp
  livemodule.cpp
  ltree.cpp
  membuf.cpp
  memhash.cpp
  memory.cpp
  mempool.cpp
  modloader.cpp
  module.cpp
  pagedict.cpp
  path.cpp
  pcode.cpp
  poopseq.cpp
  proptable.cpp
  rampmode.cpp
  rangeseq.cpp
  reflectobject.cpp
  rosstream.cpp
  runtime.cpp
  sequence.cpp
  service.cpp
  smba.cpp
  src_lexer.cpp
  stackframe.cpp
  stream.cpp
  streambuffer.cpp
  string.cpp
  stringitem.cpp
  stringstream.cpp
  strtable.cpp
  symbol.cpp
  symtab.cpp
  syntree.cpp
  timestamp.cpp
  trace.cpp
  traits.cpp
  transcoding.cpp
  tokenizer.cpp
  uri.cpp
  vfsprovider.cpp
  vmcontext.cpp
  vm.cpp
  vmmaps.cpp
  vmmsg.cpp
  vm_run.cpp
  vmsema.cpp
  #
  src_parser.hpp
  src_parser.cpp
  #
  
  ${FALCON_HEADERS}
  
  ${CORE_MODULE_SOURCES}
  ${SYS_SPECIFIC}
)

set_target_properties(falcon_engine PROPERTIES
  VERSION "${FALCON_SONAME_VERSION}.${FALCON_SONAME_REVISION}.${FALCON_SONAME_AGE}"
  SOVERSION "${FALCON_SONAME_VERSION}"
)

#In unix and mac we have to add extra libraries
if(UNIX OR APPLE)
  #also dl for linux and solaris
  # and RT only for solaris and non-bsd systems
  set(SYS_LIBS pthread m)
  if(APPLE)
    list(APPEND SYS_LIBS dl)
  else()
    IF(CMAKE_SYSTEM_NAME MATCHES ".*BSD")
    else()
      list(APPEND SYS_LIBS dl rt)
    endif()
  endif()
  target_link_libraries(falcon_engine ${SYS_LIBS})
endif()

install(TARGETS falcon_engine 
  EXPORT falcon-core-targets
  ${FALCON_INSTALL_DESTINATIONS} 
)

=== core/include/CMakeLists.txt ===
####################################################################
# The Falcon Programming language
#
# Install header files for module development
###################################################################

configure_file( 
  falcon/config.h.in  ${CMAKE_CURRENT_BINARY_DIR}/falcon/config.h
  @ONLY 
)

file(GLOB falcon_files "falcon/*.h" )
list(APPEND falcon_files ${CMAKE_CURRENT_BINARY_DIR}/falcon/config.h)

install(FILES ${falcon_files} DESTINATION ${FALCON_INC_DIR}/falcon)

=== modules/feathers/CMakeLists.txt ===
####################################################################
# The Falcon Programming language
#
# CMake configuration file for Feather modules
####################################################################
cmake_minimum_required(VERSION 2.6.2)
PROJECT(Falcon_Feathers)

# Find our Find*.cmake files 
list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake/modules)

find_package(falcon
   HINTS "$ENV{FALCON_ACTIVE_TREE}/*/*/cmake"
         "$ENV{FALCON_ACTIVE_TREE}/*/cmake"
         "$ENV{FALCON_ACTIVE_TREE}/cmake"
   REQUIRED)

add_subdirectory(compiler)
add_subdirectory(confparser)
add_subdirectory(funcext)
add_subdirectory(json)
add_subdirectory(logging)
add_subdirectory(mxml)
add_subdirectory(process)
add_subdirectory(regex)
add_subdirectory(socket)
add_subdirectory(threading)
add_subdirectory(zlib)

# install headers
add_subdirectory(include)

option(FALCON_WITH_CTEST_TESTS "" off)
if(FALCON_WITH_CTEST_TESTS)
  enable_testing()
  include(CTest)
  add_subdirectory(tests)
endif()

=== core/clt/falcon/CMakeLists.txt ===
##################################################
# Falcon Programming Language
#
# Falcon command line
##################################################
option(FALCON_WITH_READLINE "Switch to ON for readline support." off)
option(FALCON_WITH_INTERNAL_EDITLINE "" OFF)
option(FALCON_WITH_EDITLINE "" OFF)

if(WIN32)
   set(readline_SRC readline_simple.cpp)
   set( SYSTEM_RC falcon.rc)
else()  
   if(FALCON_WITH_READLINE)
     set(readline_SRC readline_simple.cpp)
   else()
     if(FALCON_WITH_INTERNAL_EDITLINE)
       add_subdirectory(editline)
       set(readline_SRC readline_editline.cpp)
       set(Editline_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/editline/src)
       set(Editline_LIBRARY edit)
     else()
        if(FALCON_WITH_EDITLINE)
           find_package(Editline REQUIRED)
           set(readline_SRC readline_editline.cpp)
        else()
           set(readline_SRC readline_simple.cpp)
        endif()
     endif()
  endif(FALCON_WITH_READLINE)
endif(WIN32)

include_directories(
  ${PROJECT_BINARY_DIR}/include
  ${PROJECT_SOURCE_DIR}/include
  ${Editline_INCLUDE_DIRS}
  
)

add_executable( falcon
   falcon.cpp
   int_mode.cpp
   options.cpp
   ${readline_SRC}
   ${SYSTEM_RC}
)
if(EDITLINE_FOUND AND FALCON_WITH_GPL_READLINE)
  set_target_properties(falcon PROPERTIES 
    COMPILE_DEFINITIONS FALCON_WITH_GPL_READLINE
  )
endif()
target_link_libraries(falcon 
  falcon_engine
  ${Editline_LIBRARY}
)

install( TARGETS falcon ${FALCON_INSTALL_DESTINATIONS})

=== modules/feathers/compiler/CMakeLists.txt ===
####################################################################
# The Falcon Programming language
#
# CMake configuration file for module Compiler
####################################################################

include_directories(
  ${PROJECT_SOURCE_DIR}/include
  ${falcon_INCLUDE_DIRS}
)

if(WIN32)
   set( SYS_RC compiler.rc )
endif()

add_library(compiler_fm MODULE
  compiler.cpp
  compiler_ext.cpp
  compiler_mod.cpp
  compiler_st.cpp
  ${SYS_RC}
)

falcon_finalize_module( compiler_fm )

=== modules/feathers/confparser/CMakeLists.txt ===
####################################################################
# The Falcon Programming language
#
# CMake configuration file for module ConfParser
####################################################################

INCLUDE_DIRECTORIES(
  ${PROJECT_SOURCE_DIR}/include
  ${falcon_INCLUDE_DIRS}
)

if(WIN32)
   set( SYS_RC confparser.rc )
endif(WIN32)

add_library(confparser_fm MODULE
  confparser.cpp
  confparser_ext.cpp
  confparser_mod.cpp
  confparser_st.cpp
  confparser_srv.cpp
  ${SYS_RC}
)

falcon_finalize_module( confparser_fm )

=== modules/feathers/funcext/CMakeLists.txt ===
####################################################################
# The Falcon Programming language
#
# CMake configuration file for module Funcext
####################################################################

include_directories(
  ${PROJECT_SOURCE_DIR}/include
  ${falcon_INCLUDE_DIRS}
)

if(WIN32)
   SET( SYS_RC funcext.rc )
endif()

add_library(funcext_fm MODULE
  funcext.cpp
  funcext_ext.cpp
  ${SYS_RC}
)

falcon_finalize_module( funcext_fm )

=== modules/feathers/include/CMakeLists.txt ===
####################################################################
# The Falcon Programming language
#
# Install service directories for services offered by modules
####################################################################

file(GLOB service_headers "falcon/srv/*.h" )

install(
  FILES ${service_headers}
  DESTINATION ${falcon_INCLUDE_DIR}/falcon/srv
)

=== modules/feathers/json/CMakeLists.txt ===
####################################################################
# The Falcon Programming language
#
# CMake configuration file for module json
####################################################################

include_directories(
  ${PROJECT_SOURCE_DIR}/include
  ${falcon_INCLUDE_DIRS}
)

if(WIN32)
   SET( SYS_RC json.rc )
endif()

add_library(json_fm MODULE
   json_st.cpp
   json_mod.cpp
   json_ext.cpp
   json_srv.cpp
   json.cpp
   ${SYS_RC}
)

falcon_finalize_module( json_fm )

## falconpl 0.9.6.5

=== core/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-##############################################################################
+#############################################################################
 # The Falcon Programming language
 #
 # CMake configuration file for Core falcon
@@ -6,29 +6,37 @@
 #
 # CONTROL VARIABLES:
 #
-# CMAKE_INSTALL_PREFIX - Installation directory
-# FALCON_FINAL_DEST - Target final destination, if different from
-#                    prefix, where Falcon will be finally installed.
-#                    If not given, will be defaulted to CMAKE_INSTALL_PREFIX
-# FALCON_BIN_DIR - Prefix for binary installation. Defaults to "bin"
-# FALCON_INC_DIR - Prefix for installation of include files.
-# FALCON_MAN_DIR - Prefix for installation of man files.
-# FALCON_LIB_DIR - Prefix for installation of archives and dynamic libraries
+# CMAKE_INSTALL_PREFIX - Installation prefix
+# FALCON_FINAL_DEST - Final destination (if != from prefix)
+# FALCON_BIN_DIR - Suffix for binary installation. Defaults to "bin"
+# FALCON_INC_DIR - Suffix for installation of include files.
+# FALCON_MAN_DIR - Suffix for installation of man files.
+# FALCON_LIB_DIR - Suffix for installation of archives and dynamic libraries
 #                  on UNIXes. Defaults to "lib".
-# FALCON_MOD_DIR - Prefix for installation of modules. Defaults to
+# FALCON_MOD_DIR - Suffix for installation of modules. Defaults to
 #                  $FALCON_LIB_DIR/falcon on UNICES, and bin/ on windows.
 # FALCON_SKIP_BISON - ON to avoid using bison.
 # FALCON_WITH_MANPAGES - ON to build and install man pages.
 # FALCON_MAN_DIR - Where manual pages are stored (below prefix)
-# DISABLE_RPATH  - Disable our detected settings for RPATH?
-#                  (should then use command line CMAKE_RPATH* variables)
-#
+# FALCON_DISABLE_RPATH  - Disable our detected settings for RPATH
+#                  (should then use command line CMAKE_*_RPATH variables)
+# FALCON_RPATH - Set RPATH or similar variables on the target systems.
+#
+# FALCON_WITH_FEATHERS=<dir> - Build also feathers as a part of this project.
+#                        Use the relative directory to describe where
+#                        Feathers are to be found.
 
 cmake_minimum_required(VERSION 2.6.2)
 project(Falcon_Core)
 
 option( FALCON_SKIP_BISON "Skip BISON to avoid recompiling grammar" ON )
-option( FALCON_WITH_MANPAGES "Build and install also manpages" OFF )
+
+if(WIN32)
+	option( FALCON_WITH_MANPAGES "Build and install also manpages" OFF )
+else()
+	# Manpages are mandatory on unix
+	option( FALCON_WITH_MANPAGES "Build and install also manpages" ON )
+endif()
 
 list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)
 
@@ -114,14 +122,12 @@
   endif()
 endif()
 
+if(NOT FALCON_FINAL_DEST)
+   set(FALCON_FINAL_DEST ${CMAKE_INSTALL_PREFIX})
+endif()
+
 message( STATUS "Installation prefix: ${CMAKE_INSTALL_PREFIX}" )
-
-if (NOT FALCON_FINAL_DEST )
-   set( FALCON_FINAL_DEST "${CMAKE_INSTALL_PREFIX}" )
-   message( "Defaulting FALCON_FINAL_DESTINATION to ${FALCON_FINAL_DEST}" )
-else()
-   message( "setting FALCON_FINAL_DESTINATION=${FALCON_FINAL_DEST}" )
-endif()
+message( STATUS "Final destination prefix: ${FALCON_FINAL_DEST}" )
 
 if (NOT FALCON_LIB_DIR)
    set(FALCON_LIB_DIR lib)
@@ -147,6 +153,8 @@
       set(FALCON_MOD_DIR "${FALCON_LIB_DIR}/falcon")
    endif()
 endif()
+
+set(FALCON_APP_DIR ${FALCON_MOD_DIR}/apps)
 
 # for install(TARGETS .. ${FALCON_INSTALL_DESTINATIONS})
 set(FALCON_INSTALL_DESTINATIONS
@@ -166,18 +174,30 @@
    message( STATUS "Manual pages: ${FALCON_MAN_DIR}" )
 endif()
 
-option(DISABLE_RPATH "http://wiki.debian.org/RpathIssue" off)
-if(NOT DISABLE_RPATH)
+
+#Use specific falcon rpath if externally set
+if(FALCON_RPATH)
+   set ( _falcon_rpath ${FALCON_RPATH} )
+else()
+   set ( _falcon_rpath "${CMAKE_INSTALL_PREFIX}/${FALCON_LIB_DIR}" )
+endif()
+      
+option(FALCON_DISABLE_RPATH "http://wiki.debian.org/RpathIssue" off)
+if(NOT FALCON_DISABLE_RPATH)
   # Always find libfalcon_engine.so in build and install tree, without LD_LIBRARY_PATH.
   set(CMAKE_SKIP_BUILD_RPATH  false)
   set(CMAKE_BUILD_WITH_INSTALL_RPATH false)
-     # RPATH must always point to the final destination
-   # No matter if we installed directly there or in a temporary prefix
-   if(CMAKE_INSTALL_RPATH)
-      set(CMAKE_INSTALL_RPATH_USE_LINK_PATH true)
-   else()
-      set(CMAKE_INSTALL_RPATH "${FALCON_FINAL_DEST}/${FALCON_LIB_DIR}")
-      set(CMAKE_INSTALL_RPATH_USE_LINK_PATH true)
+  set(CMAKE_INSTALL_RPATH ${_falcon_rpath})
+  set(CMAKE_INSTALL_RPATH_USE_LINK_PATH false) 
+  
+  # Apple equivalent to RPATH is called `install_name'
+  set(CMAKE_INSTALL_NAME_DIR ${_falcon_rpath})
+else()
+
+   #If a FALCON_RPATH is on, use it nevertheless
+   if(FALCON_RPATH)
+      set(CMAKE_INSTALL_RPATH ${_falcon_rpath})
+      set(CMAKE_INSTALL_NAME_DIR ${_falcon_rpath})
    endif()
 endif()
 
@@ -185,17 +205,49 @@
 # Subdirectories
 #
 
+#collect the include files in FALCON_HEADER
+add_subdirectory(include)
+#
 add_subdirectory(engine)
 add_subdirectory(clt)
 add_subdirectory(devtools)
 
-#also performs installation of the include directory
-add_subdirectory(include)
 
 # and man pages
 if (FALCON_WITH_MANPAGES)
    add_subdirectory(manpages)   
 endif()
+
+#########################################################################
+# Feathers?
+#
+
+if( FALCON_WITH_FEATHERS )
+   Message( STATUS "Adding FEATHERS to this build -- from ${FALCON_WITH_FEATHERS}" )
+
+   include( devtools/modfunctions.cmake )
+   
+   #Using temporary prefix to install things here.
+   set(Falcon_PREFIX "${CMAKE_INSTALL_PREFIX}")
+   set(Falcon_BINARY_DIR "${Falcon_PREFIX}/${FALCON_BIN_DIR}")
+   set(Falcon_LIBRARY_DIR "${Falcon_PREFIX}/${FALCON_LIB_DIR}")
+
+   set(Falcon_APP_DIR "${Falcon_PREFIX}/${FALCON_APP_DIR}")
+   set(Falcon_MOD_DIR "${Falcon_PREFIX}/${FALCON_MOD_DIR}")
+   set(Falcon_BIN_DIR "${Falcon_PREFIX}/${FALCON_BIN_DIR}")
+   set(Falcon_LIB_DIR "${Falcon_PREFIX}/${FALCON_LIB_DIR}")
+   set(Falcon_MAN_DIR "${Falcon_PREFIX}/${FALCON_MAN_DIR}")
+   set(Falcon_INC_DIR "${Falcon_PREFIX}/${FALCON_INC_DIR}")
+   set(Falcon_ARCH_DIR "${Falcon_PREFIX}/${FALCON_LIB_DIR}")
+
+   #this is the dir during build
+   list( APPEND Falcon_INCLUDE_DIRS "${CMAKE_CURRENT_BINARY_DIR}/include" )
+   list( APPEND Falcon_INCLUDE_DIRS "${CMAKE_CURRENT_SOURCE_DIR}/include" )
+   list( APPEND Falcon_LIBRARIES falcon_engine)
+
+   add_subdirectory( ${FALCON_WITH_FEATHERS} binary_dir )
+endif()
+
 
 #########################################################################
 # Tests?
@@ -209,5 +261,5 @@
 
 # CMake generated information.  Is used by our falcon-config.cmake
 install(EXPORT falcon-core-targets
-  DESTINATION ${FALCON_MOD_DIR}/cmake
+  DESTINATION lib/falcon/cmake
 )

=== core/devtools/CMakeLists.txt ===
--- 
+++ 
@@ -24,12 +24,13 @@
 # It supplies include paths, libraries (via falcon-core-targets.cmake)
 # and convenience MACROS.
 #
-message( "Configuring falcon-config.cmake" )
+message( "Configuring FalconConfig.cmake" )
 configure_file(
-  falcon-config.cmake.in
-  ${CMAKE_CURRENT_BINARY_DIR}/falcon-config.cmake
+  FalconConfig.cmake.in
+  ${CMAKE_CURRENT_BINARY_DIR}/FalconConfig.cmake
   @ONLY
 )
+
 
 ########################################################################
 # Install
@@ -50,6 +51,8 @@
               WORLD_READ WORLD_EXECUTE
 )
 
-install(FILES ${CMAKE_CURRENT_BINARY_DIR}/falcon-config.cmake
+install(FILES
+   ${CMAKE_CURRENT_BINARY_DIR}/FalconConfig.cmake
+   modfunctions.cmake
   DESTINATION ${FALCON_MOD_DIR}/cmake
 )

=== core/engine/CMakeLists.txt ===
--- 
+++ 
@@ -95,11 +95,6 @@
     signals_win.cpp
   )
 endif()
-
-#####################################################################################
-# Including headers in the source list helps CMAKE to build better IDE project files.
-
-file(GLOB FALCON_HEADERS "../include/falcon/*.h" )
 
 #################

=== core/include/CMakeLists.txt ===
####################################################################
# The Falcon Programming language
#
# Install header files for module development
###################################################################

configure_file( 
  falcon/config.h.in  ${CMAKE_CURRENT_BINARY_DIR}/falcon/config.h
  @ONLY 
)

set(falcon_files 
  falcon/allocator.h
  falcon/attribmap.h
  falcon/autocstring.h
  falcon/autowstring.h
  falcon/basealloc.h
  falcon/baton.h
  falcon/cacheobject.h
  falcon/callpoint.h
  falcon/carray.h
  falcon/cclass.h
  falcon/citerator.h
  falcon/common.h
  falcon/compiler.h
  falcon/complex.h
  falcon/continuation.h
  falcon/corecarrier.h
  falcon/coredict.h
  falcon/core_ext.h
  falcon/corefunc.h
  falcon/coreobject.h
  falcon/corerange.h
  falcon/coreslot.h
  falcon/coretable.h
  falcon/crobject.h
  falcon/debug.h
  falcon/deepitem.h
  falcon/deptab.h
  falcon/destroyable.h
  falcon/detmempool.h
  falcon/dir_sys.h
  falcon/dir_sys_unix.h
  falcon/dir_sys_win.h
  falcon/dll_base.h
  falcon/dll_dl.h
  falcon/dll.h
  falcon/dll_mac.h
  falcon/dll_win.h
  falcon/engine.h
  falcon/eng_messages.h
  falcon/engstrings.h
  falcon/error_base.h
  falcon/error.h
  falcon/falcondata.h
  falcon/falconobject.h
  falcon/fassert.h
  falcon/filestat.h
  falcon/flexymodule.h
  falcon/format.h
  falcon/fstream.h
  falcon/fstream_sys_unix.h
  falcon/fstream_sys_win.h
  falcon/garbageable.h
  falcon/garbagelock.h
  falcon/garbagepointer.h
  falcon/gcalloc.h
  falcon/gencode.h
  falcon/generator.h
  falcon/generatorseq.h
  falcon/genericlist.h
  falcon/genericmap.h
  falcon/genericvector.h
  falcon/genhasm.h
  falcon/gentree.h
  falcon/globals.h
  falcon/gpage.h
  falcon/heap.h
  falcon/heap_linux.h
  falcon/heap_win.h
  falcon/intcomp.h
  falcon/itemarray.h
  falcon/itemdict.h
  falcon/item.h
  falcon/itemid.h
  falcon/itemlist.h
  falcon/itempage.h
  falcon/itemset.h
  falcon/itemtraits.h
  falcon/iterator.h
  falcon/itm_deref.h
  falcon/lineardict.h
  falcon/linemap.h
  falcon/livemodule.h
  falcon/llist.h
  falcon/ltree.h
  falcon/memblock.h
  falcon/membuf.h
  falcon/memory.h
  falcon/mempool.h
  falcon/mersennetwister.h
  falcon/message_defs.h
  falcon/modloader.h
  falcon/module.h
  falcon/mt.h
  falcon/mt_posix.h
  falcon/mt_win.h
  falcon/objectfactory.h
  falcon/pagedict.h
  falcon/path.h
  falcon/pcode.h
  falcon/pcodes.h
  falcon/pointerpage.h
  falcon/poopseq.h
  falcon/proptable.h
  falcon/rampmode.h
  falcon/rangeseq.h
  falcon/rc_version.h
  falcon/refcount.h
  falcon/reflectfunc.h
  falcon/reflectobject.h
  falcon/refstring.h
  falcon/rosstream.h
  falcon/runtime.h
  falcon/sequence.h
  falcon/service.h
  falcon/setup.h
  falcon/signals.h
  falcon/signals_posix.h
  falcon/smba.h
  falcon/spage.h
  falcon/src_lexer.h
  falcon/stackframe.h
  falcon/stdstreams.h
  falcon/streambuffer.h
  falcon/stream.h
  falcon/string.h
  falcon/stringstream.h
  falcon/stringstream_srv.h
  falcon/stringwithid.h
  falcon/strtable.h
  falcon/symbol.h
  falcon/symlist.h
  falcon/symtab.h
  falcon/syntree.h
  falcon/sys.h
  falcon/testsuite.h
  falcon/timestamp.h
  falcon/time_sys.h
  falcon/time_sys_unix.h
  falcon/time_sys_win.h
  falcon/tokenizer.h
  falcon/trace.h
  falcon/traits.h
  falcon/transcoding.h
  falcon/types.h
  falcon/uintpair.h
  falcon/uri.h
  falcon/vardef.h
  falcon/vfs_file.h
  falcon/vfsprovider.h
  falcon/vmcontext.h
  falcon/vmevent.h
  falcon/vm.h
  falcon/vmmaps.h
  falcon/vmmsg.h
  falcon/vm_sys.h
  falcon/vm_sys_posix.h
  falcon/vm_sys_win.h
  falcon/xtree_fix.h
)
unset(FALCON_HEADERS)
foreach(item ${falcon_files})
  list(APPEND FALCON_HEADERS ${CMAKE_CURRENT_SOURCE_DIR}/${item})
endforeach(item ${falcon_files})
list(APPEND FALCON_HEADERS ${CMAKE_CURRENT_BINARY_DIR}/falcon/config.h)

install(FILES ${FALCON_HEADERS} DESTINATION ${FALCON_INC_DIR}/falcon)

set(FALCON_HEADERS ${FALCON_HEADERS} PARENT_SCOPE)

=== modules/feathers/CMakeLists.txt ===
--- 
+++ 
@@ -3,21 +3,29 @@
 #
 # CMake configuration file for Feather modules
 ####################################################################
-cmake_minimum_required(VERSION 2.6.2)
+cmake_minimum_required(VERSION 2.8)
 PROJECT(Falcon_Feathers)
 
 # Find our Find*.cmake files 
 list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake/modules)
 
-find_package(falcon
+if( NOT Falcon_PREFIX )
+find_package(Falcon
    HINTS "$ENV{FALCON_ACTIVE_TREE}/*/*/cmake"
          "$ENV{FALCON_ACTIVE_TREE}/*/cmake"
          "$ENV{FALCON_ACTIVE_TREE}/cmake"
    REQUIRED)
+endif()
+
+include_directories(
+  ${PROJECT_SOURCE_DIR}/include
+  ${Falcon_INCLUDE_DIRS}
+)
 
 add_subdirectory(compiler)
 add_subdirectory(confparser)
 add_subdirectory(funcext)
+add_subdirectory(hash)
 add_subdirectory(json)
 add_subdirectory(logging)
 add_subdirectory(mxml)

=== core/clt/falcon/CMakeLists.txt ===
--- 
+++ 
@@ -3,31 +3,25 @@
 #
 # Falcon command line
 ##################################################
-option(FALCON_WITH_READLINE "Switch to ON for readline support." off)
+option(FALCON_WITH_READLINE "Switch to ON for readline support." OFF)
 option(FALCON_WITH_INTERNAL_EDITLINE "" OFF)
-option(FALCON_WITH_EDITLINE "" OFF)
 
 if(WIN32)
    set(readline_SRC readline_simple.cpp)
    set( SYSTEM_RC falcon.rc)
 else()  
-   if(FALCON_WITH_READLINE)
+   if(NOT FALCON_WITH_READLINE)
      set(readline_SRC readline_simple.cpp)
    else()
+     set(readline_SRC readline_editline.cpp)
      if(FALCON_WITH_INTERNAL_EDITLINE)
        add_subdirectory(editline)
-       set(readline_SRC readline_editline.cpp)
        set(Editline_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/editline/src)
        set(Editline_LIBRARY edit)
      else()
-        if(FALCON_WITH_EDITLINE)
-           find_package(Editline REQUIRED)
-           set(readline_SRC readline_editline.cpp)
-        else()
-           set(readline_SRC readline_simple.cpp)
-        endif()
+       find_package(Editline REQUIRED)
      endif()
-  endif(FALCON_WITH_READLINE)
+  endif(NOT FALCON_WITH_READLINE)
 endif(WIN32)
 
 include_directories(

=== modules/feathers/compiler/CMakeLists.txt ===
--- 
+++ 
@@ -3,11 +3,6 @@
 #
 # CMake configuration file for module Compiler
 ####################################################################
-
-include_directories(
-  ${PROJECT_SOURCE_DIR}/include
-  ${falcon_INCLUDE_DIRS}
-)
 
 if(WIN32)
    set( SYS_RC compiler.rc )

=== modules/feathers/hash/CMakeLists.txt ===
####################################################################
# @MAIN_PRJ@
#
# CMake configuration file for hash
####################################################################

# Creates the proper module file name from the project name.
falcon_define_module( CURRENT_MODULE hash )

# Inclusion settings
include_directories(
  ${CMAKE_CURRENT_SOURCE_DIR}
)
# Enable this include if the project has a private include
#include_directories( ${PROJECT_SOURCE_DIR}/include )


# Sources files the module is built from.
set(SRC_FILES 
  hash.cpp
  hash_mod.cpp
  hash_srv.cpp
  hash_st.cpp
  # add more source files starting here:
  adler32.cpp
  md2.cpp
  md4.cpp
  md5.cpp
  ripemd.cpp
  sha1.cpp
  sha256_sha224.cpp
  sha512_sha384.cpp
  tiger.cpp
  tiger_sboxes.cpp
  whirlpool.cpp

)

# These are actually not needed by cmake to build. But if omitted they won't be
# listed in the virtual file tree of Visual Studio.
set(HDR_FILES
  hash_ext.inl  
  hash_ext.h
  hash_mod.h
  hash_srv.h
  hash_st.h
  ../include/version.h
  hash_defs.h 
  # add more header files starting here:
  adler32.h
  sha1.h
  sha256_sha224.h
  sha512_sha384.h
  md2.h
  md4.h
  md5.h
  tiger.h
  whirlpool.h

)


# Builds and links from the source files
add_library( ${CURRENT_MODULE} MODULE
   ${SRC_FILES}
   ${HDR_FILES} # optional, see comment above.
)

# If your module needs some lib more, use the followings:
target_link_libraries( ${CURRENT_MODULE} falcon_engine)


falcon_install_module( ${CURRENT_MODULE} )

=== modules/feathers/process/CMakeLists.txt ===
####################################################################
# The Falcon Programming language
#
# CMake configuration file for module Process
####################################################################

if(UNIX)
   SET(SYS_SPECIFIC process_sys_unix.cpp)
else()
   SET(SYS_SPECIFIC process_sys_win.cpp process.rc)
endif()

add_library(process_fm MODULE
   process.cpp
   process_ext.cpp
   process_mod.cpp
   process_st.cpp
   ${SYS_SPECIFIC}
)

falcon_finalize_module( process_fm )

=== modules/feathers/regex/CMakeLists.txt ===
####################################################################
# The Falcon Programming language
#
# CMake configuration file for module Regex
####################################################################

if( WIN32 OR APPLE )
   option(FALCON_WITH_INTERNAL_PCRE "Use internal pcre library" on)
else( WIN32 OR APPLE )
   option(FALCON_WITH_INTERNAL_PCRE "Use internal pcre library" off)
endif( WIN32 OR APPLE)

if(WIN32)
   set( SYS_RC regex.rc)
endif(WIN32)

if(FALCON_WITH_INTERNAL_PCRE)
   #include local headers BEFORE
   include_directories(${CMAKE_CURRENT_SOURCE_DIR})

   #Compile our version of PCRE...
   SET(PCRE_SOURCE
      pcre_chartables.c
      pcre_compile.c
      pcre_config.c
      pcre_exec.c
      pcre_fullinfo.c
      pcre_get.c
      pcre_info.c
      pcre_maketables.c
      pcre_newline.c
      pcre_ord2utf8.c
      pcre_refcount.c
      pcre_study.c
      pcre_tables.c
      pcre_try_flipped.c
      pcre_ucd.c
      pcre_valid_utf8.c
      pcre_version.c
      pcre_xclass.c
   )

   add_definitions(-DHAVE_CONFIG_H -DPCRE_STATIC -DPCRE_EXP_DATA_DECL=extern -DPCRE_EXP_DECL=extern -DPCRE_EXP_DEFN=)
    
   # This is an hack for systems where pcre is already hard-linked inside embedding c programs
   # Mangle names as C++, so it doesn't get the already-linked system pcre build.
   #if(NOT WIN32)
	   set_source_files_properties(
		  ${PCRE_SOURCE} PROPERTIES 
		  LANGUAGE "CXX"
	   )
   #endif()
   
else()
   find_package(PCRE REQUIRED)   
   # Force ignoring OUR pcre
   include_directories(${PCRE_INCLUDE_DIR}) 
endif(FALCON_WITH_INTERNAL_PCRE)

add_library(regex_fm MODULE
  regex.cpp
  regex_ext.cpp
  regex_mod.cpp
  regex_st.cpp
  ${PCRE_SOURCE}
  ${SYS_RC}
)

target_link_libraries(regex_fm 
  falcon_engine 
  ${PCRE_LIBRARIES}
)

falcon_install_module( regex_fm )

=== modules/feathers/zlib/CMakeLists.txt ===
####################################################################
# The Falcon Programming language
#
# CMake configuration file for module Process
####################################################################

if( WIN32 OR APPLE )
   option(FALCON_WITH_INTERNAL_ZLIB "Use internal zlib library" ON)
else( WIN32 OR APPLE )
   option(FALCON_WITH_INTERNAL_ZLIB "Use internal zlib library" OFF)
endif( WIN32 OR APPLE)

include_directories(
  ${CMAKE_CURRENT_SOURCE_DIR}
)

if(WIN32)
   set(SYS_SPECIFIC zlib.rc)
endif()

if(FALCON_WITH_INTERNAL_ZLIB)
  set(ZLIB_LIBRARY "")
  set(ZLIB_SOURCE
    adler32.c
    compress.c
    crc32.c
    deflate.c
    gzio.c
    infback.c
    inffast.c
    inflate.c
    inftrees.c
    trees.c
    uncompr.c
    zutil.c
    ${SYS_SPECIFIC}
  )
else(FALCON_WITH_INTERNAL_ZLIB)
   find_package(ZLIB REQUIRED)
   include_directories(${ZLIB_INCLUDE_DIR})
endif(FALCON_WITH_INTERNAL_ZLIB)

# Target
add_library(zlib_fm MODULE
   ${ZLIB_SOURCE}
   # ZLib module source
   zlib.cpp
   zlib_ext.cpp
   zlib_st.cpp
   #zlibstream.cpp
)

target_link_libraries(zlib_fm falcon_engine ${ZLIB_LIBRARIES})

falcon_install_module( zlib_fm )

=== debian/changelog ===
falconpl (0.9.6.5-0ubuntu1) maverick; urgency=low

  * New upstream release.
  * Switch to 3.0 (quilt) format.

 -- Alessio Treglia <quadrispro@ubuntu.com>  Wed, 12 May 2010 14:41:47 +0200

falconpl (0.9.6.4-0ubuntu1) lucid; urgency=low

  * New upstream bugfix release.

 -- Alessio Treglia <quadrispro@ubuntu.com>  Mon, 15 Mar 2010 07:02:32 +0100

falconpl (0.9.6.2-0ubuntu1) lucid; urgency=low

  * New upstream release.
  * Bump Standards.
  * Adjust debheper build-dependency to ease backporters' life.

 -- Alessio Treglia <quadrispro@ubuntu.com>  Wed, 17 Feb 2010 19:08:03 +0100

falconpl (0.9.4.4-0ubuntu1) lucid; urgency=low

  * New upstream release.
  * debian/{compat,control,rules}: Switch to debhelper 7.
  * debian/control:
    - Bump Standards.
    - Add ${misc:Depends} macro to all Depends fields.
    - Move -dbg packages to debug section.

 -- Alessio Treglia <quadrispro@ubuntu.com>  Thu, 05 Nov 2009 13:16:33 +0100

falconpl (0.9.4-0ubuntu1) karmic; urgency=low

  * New upstream release (LP: #412545).
  * debian/copyright:
    - Update copyright info.
    - Refers to the specific version of GPL that the package references.
  * debian/control:
    - Remove duplicate section field.

 -- Alessio Treglia <quadrispro@ubuntu.com>  Thu, 13 Aug 2009 08:11:46 +0200

falconpl (0.9.2-0ubuntu1) karmic; urgency=low

  * New upstream release. LP: #394602
  * Standards-Version is 3.8.2. No changes needed.

 -- Bhavani Shankar <right2bhavi@gmail.com>  Sun, 05 Jul 2009 11:21:11 +0530

falconpl (0.9.1.8-0ubuntu1) karmic; urgency=low

  * New upstream release.
  * debian/copyright: Replace (C) with © symbol.

 -- Alessio Treglia <quadrispro@ubuntu.com>  Wed, 20 May 2009 15:07:30 +0200

falconpl (0.8.14.2-0ubuntu1) jaunty; urgency=low

  * New upstream bugfix release.
  * debian/watch: fix for the new tarballs location.

 -- Emilio Pozuelo Monfort <pochu@ubuntu.com>  Fri, 26 Dec 2008 22:52:36 +0100

falconpl (0.8.14-0ubuntu1) jaunty; urgency=low

  * New upstream release.
  * Standards-Version is 3.8.0. No changes needed.

 -- Emilio Pozuelo Monfort <pochu@ubuntu.com>  Mon, 15 Dec 2008 14:22:27 +0100

falconpl (0.8.10.2-0ubuntu1) intrepid; urgency=low

  * New upstream release with support for cmake 2.6, fixes FTBFS in
    Intrepid.

 -- Emilio Pozuelo Monfort <pochu@ubuntu.com>  Fri, 13 Jun 2008 17:14:32 +0200

falconpl (0.8.10-0ubuntu1) intrepid; urgency=low

  * New upstream release
    - debian/copyright:
      + Updated to mention that falconpl is now dual-licensed under the
        GPL2+
  * debian/control:
    - Added missing shlibs:Depends to libfalcon-dev

 -- Emilio Pozuelo Monfort <pochu@ubuntu.com>  Thu, 05 Jun 2008 16:39:54 +0200

falconpl (0.8.8-0ubuntu2) hardy; urgency=low

  * debian/control:
    - s/shlib/shlibs/g (LP: #192001)

 -- Mario Limonciello <superm1@ubuntu.com>  Thu, 14 Feb 2008 19:13:09 -0600

falconpl (0.8.8-0ubuntu1) hardy; urgency=low

   * Initial release (LP: #174470)

 -- Giancarlo Niccolai <gc@falconpl.org>  Sat, 19 Jan 2008 00:06:23 +0100

=== debian/control ===
Source: falconpl
Section: interpreters
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Giancarlo Niccolai <gc@falconpl.org>
Standards-Version: 3.8.4
Build-Depends: cmake (>= 2.0),
 debhelper (>= 7.0.50~),
 bison (>= 1.8),
 zlib1g-dev,
 libpcre3-dev (>= 7.0)
Homepage: http://www.falconpl.org

Package: libfalcon-engine1
Architecture: any
Section: libs
Suggests: falconpl (= ${binary:Version})
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: The Falcon Programming Language engine
 Falcon is a small, fast and powerful embeddable programming
 language. It is currently available for MS-Windows, Linux and
 Mac OS X platforms.
 .
 Falcon aims to be the next generation scripting language,
 providing a wide set of programming paradigms, template file
 processing for web development and document based applications,
 radical internationalization and application extension support.
 It is distributed under the Falcon Programming Language License,
 an open source license which grants usability of the language
 in any kind of application, including commercial ones.
 .
 This is the main engine of the language, including the engine,
 the Runtime Library and the essential modules.

Package: libfalcon-engine1-dbg
Architecture: any
Priority: extra
Section: debug
Suggests: libfalcon-engine1-dev (= ${binary:Version})
Depends: libfalcon-engine1 (= ${binary:Version}), ${misc:Depends}
Description: The Falcon P.L. engine - debugging symbols
 Falcon is a small, fast and powerful embeddable programming
 language. It is currently available for MS-Windows, Linux and
 Mac OS X platforms.
 .
 Falcon aims to be the next generation scripting language,
 providing a wide set of programming paradigms, template file
 processing for web development and document based applications,
 radical internationalization and application extension support.
 It is distributed under the Falcon Programming Language License,
 an open source license which grants usability of the language
 in any kind of application, including commercial ones.
 .
 This package contains the debugging symbols for libfalcon-engine1
 package.

Package: falconpl
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
         libfalcon-engine1 (= ${binary:Version})
Description: The Falcon P. L. - command line tools
 Falcon is a small, fast and powerful embeddable programming
 language. It is currently available for MS-Windows, Linux and
 Mac OS X platforms.
 .
 This is the set of command line tools that can be used to run
 stand-alone scripts and applications.

Package: falconpl-dbg
Architecture: any
Priority: extra
Section: debug
Suggests: falconpl-dev (= ${binary:Version})
Depends: ${shlibs:Depends}, ${misc:Depends},
         falconpl (= ${binary:Version})
Description: The Falcon P. L. - debugging symbols
 Falcon is a small, fast and powerful embeddable programming
 language. It is currently available for MS-Windows, Linux and
 Mac OS X platforms.
 .
 This package contains the debugging symbols for the falconpl
 package.

Package: falconpl-dev
Architecture: any
Section: devel
Depends: ${shlibs:Depends}, ${misc:Depends},
         falconpl (= ${binary:Version})
Description: The Falcon PL - development files
 Falcon is a small, fast and powerful embeddable programming
 language. It is currently available for MS-Windows, Linux and
 Mac OS X platforms.
 .
 These are the files needed to develop new Falcon modules or
 to embed the Falcon Programming Language in other applications.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_clean:
	rm -rf devel/release devel/settings*
	dh_auto_clean

override_dh_auto_configure:

override_dh_auto_build:
	$(CURDIR)/build.sh -s -p $(CURDIR)/debian/tmp/usr -f /usr

override_dh_auto_install:
	$(CURDIR)/build.sh -i

override_dh_install:
	dh_install -plibfalcon-engine1 --sourcedir=debian/tmp
	dh_install -pfalconpl --sourcedir=debian/tmp
	dh_install -pfalconpl-dev --sourcedir=debian/tmp

override_dh_strip:
	dh_strip -plibfalcon-engine1 --dbg-package=libfalcon-engine1-dbg
	dh_strip -pfalconpl --dbg-package=falconpl-dbg
	dh_strip -pfalconpl-dev

override_dh_makeshlibs:
	dh_makeshlibs -plibfalcon-engine1 -V
